
package de.ivu.elect.presentation.gruppe;

import javax.annotation.Nullable;
import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gruppe.boundary.GruppeUebernehmen;
import de.ivu.elect.business.gruppe.entity.GruppeUebernehmenParameter;
import de.ivu.elect.business.gruppe.entity.GruppeUebernehmenResult;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.dynamicform.LambdaBooleanProperty;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.AbstractElectCreateView;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.wahl.form.WahlListeInSelectOneMenuFuerEntityUebernahmeBuilder;

@RequestScoped
@Named(GruppeUebernehmenView.COMPONENT_NAME)
@View(viewId = GruppeUebernehmenView.VIEW_ID, useCase = UseCasePermission.GRUPPE_UEBERNEHMEN)
public class GruppeUebernehmenView extends AbstractElectCreateView<GruppeUebernehmenParameter> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeUebernehmenView";

  public static final String VIEW_ID = "/gruppe/gruppe-uebernehmen.xhtml";

  public static final String PARENT_VIEW_ID = GruppeSearchView.VIEW_ID;

  @Inject
  private transient GruppeUebernehmen gruppeUebernehmen;

  @Inject
  private transient WahlListeInSelectOneMenuFuerEntityUebernahmeBuilder wahlListeInSelectOneMenuFuerEntityUebernahmeBuilder;

  private GruppeUebernehmenParameter entity;

  public GruppeUebernehmenView() {
    super();
  }

  @PreConditionCheck
  @Nullable
  public String checkCondition() {
    if (!isWahlSelected()) {
      return cancel();
    }

    return null;
  }

  @PostConstruct
  public void init() {
    var gruppeUebernehmenParameter = new GruppeUebernehmenParameter();
    gruppeUebernehmenParameter.setWahlZiel(getSelectedWahl());

    setEntity(gruppeUebernehmenParameter);
  }

  @Override
  protected GruppeUebernehmenParameter getEntity() {
    return entity;
  }

  protected void setEntity(GruppeUebernehmenParameter entity) {
    this.entity = entity;
  }

  @Override
  protected void addProperties(FormBuilder formBuilder, GruppeUebernehmenParameter entity) {
    wahlListeInSelectOneMenuFuerEntityUebernahmeBuilder.addProperties(formBuilder, getEntity(), "gruppe.uebernehmen.quell.wahl");

    formBuilder.addProperty(
        new LambdaBooleanProperty(getMessage("gruppe.uebernehmen.gruppen.aktualisieren"), true, true, getEntity()::setGruppenAktualisierenWennSchonVorhanden,
            getEntity()::isGruppenAktualisierenWennSchonVorhanden));

    formBuilder.addProperty(
        new LambdaBooleanProperty(getMessage("gruppe.uebernehmen.gruppen.loeschen"), false, true, getEntity()::setUeberzaehligeGruppenLoeschen,
            getEntity()::isUeberzaehligeGruppenLoeschen));

  }

  @Override
  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.GRUPPE_UEBERNEHMEN);
  }

  @Override
  @Redirect
  public String save() {
    var result = gruppeUebernehmen.save(getEntity());

    if (result.equals(GruppeUebernehmenResult.NICHTS_UEBRNOMMEN)) {
      addWarningMessage("gruppe.uebernehmen.nichts.uebernommen");
    }

    if (result.getAnzahlUebernommenerGruppen() > 0L) {
      addInfoMessage("gruppe.uebernehmen.uebernommen", result.getAnzahlUebernommenerGruppen());
    }

    if (result.getAnzahlBereitsVorhandenerGruppen() > 0L) {
      addInfoMessage("gruppe.uebernehmen.bereits.vorhanden", result.getAnzahlBereitsVorhandenerGruppen());
    }

    if (result.getAnzahlAktualisierterGruppen() > 0L) {
      addWarningMessage("gruppe.uebernehmen.aktualisiert", result.getAnzahlAktualisierterGruppen());
    }

    if (result.getAnzahlGeloeschterGruppen() > 0L) {
      addWarningMessage("gruppe.uebernehmen.geloescht", result.getAnzahlGeloeschterGruppen());
    }

    if (result.getAnzahlUebernommenerGruppen() == 0L && result.getAnzahlAktualisierterGruppen() == 0L) {
      return VIEW_ID;
    }

    return goBack(PARENT_VIEW_ID);
  }

  @Override
  public boolean isBtnResetRendered() {
    return true;
  }

  @Nullable
  @Override
  @Redirect
  public String reset() {
    init();

    return VIEW_ID;
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Override
  @Redirect
  public String cancel() {
    return goBack(PARENT_VIEW_ID);
  }
}
